## cdogs-sdl 2.0.0+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.19)
cmake_policy(SET CMP0054 NEW)
cmake_policy(SET CMP0072 NEW)
set(CMAKE_OSX_DEPLOYMENT_TARGET 10.13)
project(cdogs-sdl C)

set(VERSION_MAJOR "2")
set(VERSION_MINOR "0")
set(VERSION_PATCH "0")
set(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")

# Optionally configure CI files since they are excluded in source archives
if(EXISTS ${CMAKE_SOURCE_DIR}/.github/workflows/cmake.yml.cmake)
	configure_file(
		${CMAKE_SOURCE_DIR}/.github/workflows/cmake.yml.cmake
		${CMAKE_SOURCE_DIR}/.github/workflows/cmake.yml
		@ONLY
	)
endif()
if(EXISTS ${CMAKE_SOURCE_DIR}/appveyor.yml.cmake)
	configure_file(
		${CMAKE_SOURCE_DIR}/appveyor.yml.cmake
		${CMAKE_SOURCE_DIR}/appveyor.yml
		@ONLY
	)
endif()

# this must be 4 numbers
set(VERSION_RC "${VERSION_MAJOR},${VERSION_MINOR},${VERSION_PATCH},0")
set(WEBSITE "http://cxong.github.io/cdogs-sdl/")

option(DEBUG "Enable debug build" OFF)
option(DEBUG_PROFILE "Enable debug profile build" OFF)
option(USE_SHARED_ENET "Use system installed copy of enet" OFF)
option(BUILD_EDITOR "Build cdogs-sdl-editor" ON)

# check for crosscompiling (defined when using a toolchain file)
if(CMAKE_CROSSCOMPILING)
	# check for gcw0
	if(CMAKE_C_COMPILER MATCHES ".*gcw0-linux.*")
		set(GCW0 1)
		set(BUILD_EDITOR OFF)
	endif()
endif()

if(CMAKE_C_COMPILER_ID MATCHES "Clang")
	set(CLANG 1)
endif()

if(WIN32)
	set(CMAKE_RC_COMPILER_INIT windres)
	enable_language(RC)
	set(CMAKE_RC_COMPILE_OBJECT
		"<CMAKE_RC_COMPILER> -O coff <DEFINES> -i <SOURCE> -o <OBJECT>")
endif()
set(LINKDIR /usr/games)

if(DEBUG)
	set(CMAKE_BUILD_TYPE "Debug")
else()
	add_definitions(-DNDEBUG)
endif()

set(CMAKE_MODULE_PATH
	${CMAKE_MODULE_PATH}
	"${CMAKE_SOURCE_DIR}/src/proto/nanopb/extra")
	
find_package(Nanopb 0.4.5...<1.0.0 REQUIRED)
find_package(SDL2 REQUIRED)
message("SDL2 include dir: ${SDL2_INCLUDE_DIRS}")
find_package(SDL2_image REQUIRED)
find_package(SDL2_mixer REQUIRED)
if(BUILD_EDITOR)
	find_package(OpenGL REQUIRED)
endif()

set(ENet_LIBRARY enet)
if(WIN32)
    set(WINDOWS_ENET_DEPENDENCIES "ws2_32;winmm")
    set(ENet_LIBRARIES ${ENet_LIBRARY} ${WINDOWS_ENET_DEPENDENCIES})
else()
    set(ENet_LIBRARIES ${ENet_LIBRARY})
endif()

if(NOT USE_SHARED_ENET)
    include_directories(src/cdogs/enet/include)
endif()

if(MSVC)
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -MP -W4 -WX -wd\"4090\" -wd\"4996\" -wd\"4204\"")
	if(DEBUG)
		add_definitions(-ZI)
	endif()
else()
	add_definitions(
		-fsigned-char
		-Wall -W
		-Wstrict-prototypes -Wpointer-arith -Wcast-qual)
	if(DEBUG)
		add_definitions(-g)
		if(DEBUG_PROFILE AND CMAKE_COMPILER_IS_GNUCC)
			add_definitions(-p)
		endif()
	else()
		add_definitions(-O2)
	endif()
	if(GCW0)
		add_definitions(-D__GCWZERO__)
	endif()
    if(CLANG)
		add_definitions(-std=gnu99)

		if(${CMAKE_C_COMPILER_VERSION} VERSION_GREATER_EQUAL 13.1)
			# TODO: used by nuklear
			add_definitions(-Wno-null-pointer-arithmetic -Wno-null-pointer-subtraction)
		endif()
    else()
        # Probably GCC...
        add_definitions(-freg-struct-return -std=gnu99)
		if(NOT APPLE AND NOT BEOS AND NOT HAIKU)
			add_definitions(-Wshadow)
		endif()
		if (CMAKE_C_COMPILER_VERSION VERSION_GREATER 7)
			add_definitions(
				-Wimplicit-fallthrough=0 # TODO: is everything caught by implicit-fallthrough intended?
				-Wno-error=format-overflow # TODO: should probably just make sure buffer sizes are appropriate
			)
		endif()
	endif()
	if(NOT BEOS AND NOT HAIKU)
		add_definitions(-Winline -Werror)
		set(EXTRA_LIBRARIES "m")
	endif()
endif()

set(CMAKE_MACOSX_RPATH 1)

if(NOT DEFINED CDOGS_DATA_DIR)
	if(GCW0)
		set(CDOGS_DATA_DIR "./")
	else()
		set(CDOGS_DATA_DIR "../")
	endif()
endif()
message("Data dir is ${CDOGS_DATA_DIR}")
if(WIN32)
	set(CDOGS_CFG_DIR "C-Dogs SDL/")
else()
	set(CDOGS_CFG_DIR ".config/cdogs-sdl/")
endif()
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ".")
if(UNIX AND NOT APPLE)
	configure_file(${CMAKE_SOURCE_DIR}/build/linux/cdogs-sdl.cmake ${CMAKE_SOURCE_DIR}/build/linux/cdogs-sdl)
	set_source_files_properties(${CMAKE_SOURCE_DIR}/build/linux/cdogs-sdl PROPERTIES GENERATED TRUE)
endif()
if(WIN32)
	configure_file(${CMAKE_SOURCE_DIR}/build/windows/cdogs.rc.cmake ${CMAKE_SOURCE_DIR}/build/windows/cdogs.rc)
	set_source_files_properties(${CMAKE_SOURCE_DIR}/build/windows/cdogs.rc PROPERTIES GENERATED TRUE)
endif()
configure_file(${CMAKE_SOURCE_DIR}/src/cdogs/sys_config.h.cmake ${CMAKE_SOURCE_DIR}/src/cdogs/sys_config.h)
set_source_files_properties(${CMAKE_SOURCE_DIR}/src/cdogs/sys_config.h PROPERTIES GENERATED TRUE)
include_directories(src src/cdogs)

# Tests
include(CTest)

add_subdirectory(src)

# Build the shared library next to cdogs-sdl
set_target_properties(cdogs-sdl PROPERTIES
	RUNTIME_OUTPUT_DIRECTORY_DEBUG ${CMAKE_CURRENT_BINARY_DIR}/src
	RUNTIME_OUTPUT_DIRECTORY_RELEASE ${CMAKE_CURRENT_BINARY_DIR}/src
)
if(BUILD_EDITOR)
	set_target_properties(cdogs-sdl-editor PROPERTIES
		RUNTIME_OUTPUT_DIRECTORY_DEBUG ${CMAKE_CURRENT_BINARY_DIR}/src
		RUNTIME_OUTPUT_DIRECTORY_RELEASE ${CMAKE_CURRENT_BINARY_DIR}/src
	)
endif()

################
# Installation #
################

# Executables
set(INSTALL_PREFIX ".")
set(EXE_EXTENSION "")
if(WIN32)
	set(EXE_EXTENSION ".exe")
	set(LIB_EXTENSION ".dll")
  set(DATA_INSTALL_DIR ".")
elseif(APPLE)
	set(LIB_EXTENSION ".dylib")
  set(DATA_INSTALL_DIR "cdogs-sdl")
	set(INSTALL_PREFIX "cdogs-sdl")
else()
	set(LIB_EXTENSION ".so")
	set(DATA_INSTALL_DIR ".")
endif()

# Since Debian wants games binaries in /usr/games
if(NOT DEFINED CDOGS_BIN_DIR)
	set(CDOGS_BIN_DIR "${INSTALL_PREFIX}/bin")
endif()

install(
  PROGRAMS
    ${CMAKE_CURRENT_BINARY_DIR}/src/cdogs-sdl${EXE_EXTENSION}
    DESTINATION ${CDOGS_BIN_DIR})
if(BUILD_EDITOR)
	install(
	  PROGRAMS
	    ${CMAKE_CURRENT_BINARY_DIR}/src/cdogs-sdl-editor${EXE_EXTENSION}
	    DESTINATION ${CDOGS_BIN_DIR})
endif()

install(DIRECTORY
	${CMAKE_SOURCE_DIR}/data
	${CMAKE_SOURCE_DIR}/missions
	${CMAKE_SOURCE_DIR}/dogfights
	${CMAKE_SOURCE_DIR}/graphics
	${CMAKE_SOURCE_DIR}/music
	${CMAKE_SOURCE_DIR}/sounds
	DESTINATION ${DATA_INSTALL_DIR})

if(NOT DEFINED CDOGS_DOC_DIR)
	set(CDOGS_DOC_DIR "${DATA_INSTALL_DIR}/doc")
endif()
install(DIRECTORY ${CMAKE_SOURCE_DIR}/doc/
	DESTINATION ${CDOGS_DOC_DIR}
	)

install(FILES
	${CMAKE_SOURCE_DIR}/README.md
	DESTINATION ${DATA_INSTALL_DIR})
if(UNIX AND NOT APPLE AND NOT BEOS AND NOT HAIKU)
	install(FILES ${CMAKE_SOURCE_DIR}/build/linux/io.github.cxong.cdogs-sdl.desktop DESTINATION ${INSTALL_PREFIX}/share/applications)
	install(FILES ${CMAKE_SOURCE_DIR}/build/linux/io.github.cxong.cdogs-sdl.appdata.xml DESTINATION ${INSTALL_PREFIX}/share/metainfo)
	foreach(RES 16 22 32 48 128)
		install(FILES ${CMAKE_SOURCE_DIR}/build/linux/cdogs-icon.${RES}.png
			DESTINATION ${INSTALL_PREFIX}/share/icons/hicolor/${RES}x${RES}/apps
			RENAME io.github.cxong.cdogs-sdl.png)
	endforeach()
elseif(WIN32)
	# Package for Windows
	file(GLOB DLLS "${CMAKE_SOURCE_DIR}/dll/*.dll")
	foreach(DLL ${DLLS})
		install(FILES "${DLL}" DESTINATION ${INSTALL_PREFIX}/bin)
	endforeach()
	install(DIRECTORY ${CMAKE_SOURCE_DIR}/build/licenses DESTINATION ${INSTALL_PREFIX})
elseif(APPLE)
	set(CMAKE_INSTALL_PREFIX "/Applications/cdogs-sdl")
endif()

# Packaging
set(CPACK_PACKAGE_NAME "C-Dogs.SDL")
set(CPACK_PACKAGE_VENDOR "C-Dogs SDL Team")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "C-Dogs SDL: Action/Arcade Game")
set(CPACK_PACKAGE_VERSION ${VERSION})
set(CPACK_PACKAGE_VERSION_MAJOR ${VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${VERSION_PATCH})
set(CPACK_PACKAGE_EXECUTABLES "cdogs-sdl;C-Dogs SDL;cdogs-sdl-editor;Campaign Editor")
if(WIN32)
	set(CPACK_GENERATOR NSIS ZIP)
	set(CPACK_NSIS_ENABLE_UNINSTALL_BEFORE_INSTALL ON)
	set(CPACK_RESOURCE_FILE_LICENSE ${CMAKE_SOURCE_DIR}/doc/COPYING.GPL)
	set(CPACK_PACKAGE_INSTALL_DIRECTORY "C-Dogs SDL")
	set(CPACK_NSIS_MUI_ICON ${CMAKE_SOURCE_DIR}/build/windows/cdogs-icon.ico)
	set(CPACK_NSIS_CREATE_ICONS "SetOutPath '\$INSTDIR\\\\bin'
	CreateShortCut '\$SMPROGRAMS\\\\$STARTMENU_FOLDER\\\\C-Dogs SDL.lnk' '\$INSTDIR\\\\bin\\\\cdogs-sdl.exe'
	CreateShortCut '\$SMPROGRAMS\\\\$STARTMENU_FOLDER\\\\Campaign Editor.lnk' '\$INSTDIR\\\\bin\\\\cdogs-sdl-editor.exe'")
	set(CPACK_NSIS_MUI_FINISHPAGE_RUN cdogs-sdl.exe)
	set(CPACK_NSIS_URL_INFO_ABOUT ${WEBSITE})
elseif(APPLE)
	set(CPACK_GENERATOR "DragNDrop")
	set(CPACK_DMG_FORMAT "UDBZ")
	set(CPACK_DMG_VOLUME_NAME "C-Dogs.SDL")
	set(CPACK_SYSTEM_NAME "OSX")
	set(CPACK_PACKAGE_ICON
		"${CMAKE_SOURCE_DIR}/build/macosx/cdogs-icon.icns")
	set(CPACK_DMG_BACKGROUND_IMAGE
		"${CMAKE_SOURCE_DIR}/build/macosx/dmg_bg.png")
	set(CPACK_DMG_DS_STORE
		"${CMAKE_SOURCE_DIR}/build/macosx/DS_Store")

	# copy SDL frameworks
	set(APPS cdogs-sdl cdogs-sdl-editor)
	set(LIBS SDL2 SDL2_image SDL2_mixer)
	foreach(APP ${APPS})
		foreach(LIB ${LIBS})
			install(DIRECTORY /Library/Frameworks/${LIB}.framework
				DESTINATION ${INSTALL_PREFIX}/Frameworks)
		endforeach()
	endforeach()
elseif(BEOS OR HAIKU)
	set(CPACK_GENERATOR TGZ)
	install(
		FILES ${CMAKE_SOURCE_DIR}/build/haiku/cdogs-sdl.sh
		DESTINATION ${INSTALL_PREFIX}
		PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)
else()
	# probably linux

	# Pack only tar.gz since deb and rpm packages may differ in distros
	set(CPACK_GENERATOR TGZ)

	# debian specific
	set(CPACK_DEBIAN_PACKAGE_MAINTAINER "C-Dogs SDL Team")
	set(CPACK_DEBIAN_PACKAGE_SECTION Games)
	set(CPACK_DEBIAN_PACKAGE_DEPENDS "libc6, libsdl2-image, libsdl2-mixer")

	# fedora/suse specific
	set(CPACK_RPM_PACKAGE_LICENSE "GPL2")
	set(CPACK_RPM_PACKAGE_GROUP "Amusements/Games/Action/Arcade")
	set(CPACK_RPM_PACKAGE_REQUIRES "sdl_image >= 2, sdl_mixer >= 2")

endif()
include(CPack)

=== src/CMakeLists.txt ===
include_directories(
	.
	proto/nanopb
	${SDL2_INCLUDE_DIRS})
if(BUILD_EDITOR)
	include_directories(${OPENGL_INCLUDE_DIRS})
endif()

add_subdirectory(cdogs)
if(BUILD_EDITOR)
	add_subdirectory(cdogsed)
endif()
add_subdirectory(json)
add_subdirectory(proto)
if(BUILD_TESTING)
	add_subdirectory(tests)
endif()

set(CDOGS_SDL_SOURCES
	ammo_menu.c
	animated_counter.c
	autosave.c
	briefing_screens.c
	cdogs.c
	command_line.c
	credits.c
	equip_menu.c
	game.c
	game_loop.c
	hiscores.c
	loading_screens.c
	mainmenu.c
	menu.c
	menu_utils.c
	namegen.c
	password.c
	player_select_menus.c
	prep.c
	prep_equip.c
	screens_end.c
	util_menu.c
	weapon_menu.c)
set(CDOGS_SDL_HEADERS
	ammo_menu.h
	animated_counter.h
	autosave.h
	briefing_screens.h
	command_line.h
	credits.h
	equip_menu.h
	game.h
	game_loop.h
	hiscores.h
	loading_screens.h
	mainmenu.h
	menu.h
	menu_utils.h
	namegen.h
	password.h
	player_select_menus.h
	prep.h
	prep_equip.h
	screens_end.h
	util_menu.h
	weapon_menu.h)
set(CDOGS_SDL_EXTRA)
if(WIN32)
	set(CDOGS_SDL_EXTRA ../build/windows/cdogs.rc)
endif()
add_executable(cdogs-sdl
	${CDOGS_SDL_SOURCES} ${CDOGS_SDL_HEADERS} ${CDOGS_SDL_EXTRA})
if(APPLE)
	set_target_properties(cdogs-sdl PROPERTIES
		MACOSX_RPATH 1
		BUILD_WITH_INSTALL_RPATH 1
		INSTALL_RPATH "@loader_path/../Frameworks")
elseif(MSVC)
	set_target_properties(cdogs-sdl PROPERTIES VS_DEBUGGER_WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}/src")
endif()
target_link_libraries(cdogs-sdl cdogs cdogs_proto ${EXTRA_LIBRARIES})

if(GCW0)
	add_custom_command(TARGET cdogs-sdl
		POST_BUILD
		COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/../build/gcw-zero/make_opk.sh ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/..
		WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/..
		COMMENT "Building cdogs-sdl.opk..."
	)
endif()

if(BUILD_EDITOR)
  add_executable(cdogs-sdl-editor cdogsed/cdogsed.c ${CDOGS_SDL_EXTRA})
  if(APPLE)
  	set_target_properties(cdogs-sdl-editor PROPERTIES
  		MACOSX_RPATH 1
  		BUILD_WITH_INSTALL_RPATH 1
  		INSTALL_RPATH "@loader_path/../Frameworks")
  elseif(MSVC)
  	set_target_properties(cdogs-sdl-editor PROPERTIES VS_DEBUGGER_WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}/src")
  endif()
  target_link_libraries(cdogs-sdl-editor cdogsedlib cdogs cdogs_proto ${OPENGL_LIBRARIES} ${EXTRA_LIBRARIES})
endif()

=== src/cdogsed/CMakeLists.txt ===
include_directories(${SDL2_INCLUDE_DIRS})
set(CDOGSED_SOURCES
	add_pickup_dialog.c
	campaign_options.c
	char_editor.c
	destroy_objective_dialog.c
	editor_brush.c
	editor_ui.c
	editor_ui_cave.c
	editor_ui_classic.c
	editor_ui_color.c
	editor_ui_common.c
	editor_ui_interior.c
	editor_ui_objectives.c
	editor_ui_static.c
	editor_ui_static_additem.c
	editor_ui_weapons.c
	exit_brush.c
	file_dialog.c
	mission_options.c
	nk_window.c
	pickup_objective_dialog.c
	tile_brush.c
	ui_object.c)
set(CDOGSED_HEADERS
	add_pickup_dialog.h
	campaign_options.h
	char_editor.h
	destroy_objective_dialog.h
	editor_brush.h
	editor_ui.h
	editor_ui_cave.h
	editor_ui_classic.h
	editor_ui_color.h
	editor_ui_common.h
	editor_ui_interior.h
	editor_ui_objectives.h
	editor_ui_static.h
	editor_ui_static_additem.h
	editor_ui_weapons.h
	exit_brush.h
	file_dialog.h
	mission_options.h
	nk_window.h
	pickup_objective_dialog.h
	tile_brush.h
	ui_object.h)
add_library(cdogsedlib STATIC ${CDOGSED_SOURCES} ${CDOGSED_HEADERS})
target_link_libraries(cdogsedlib SDL2::SDL2 SDL2_image::SDL2_image SDL2_mixer::SDL2_mixer)

=== src/cdogs/SDL_JoystickButtonNames/CMakeLists.txt ===
include_directories(${SDL2_INCLUDE_DIRS})

file(READ gamecontrollerbuttondb.txt DB)
# Escape the newlines so it appears as multi line string in C
string(REPLACE "\n" "\\n\\\n" DB ${DB})
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/db.h.cmake ${CMAKE_CURRENT_SOURCE_DIR}/db.h)
set_source_files_properties(
  ${CMAKE_CURRENT_SOURCE_DIR}/db.h PROPERTIES GENERATED TRUE)

add_library(SDL_joystickbuttonnames STATIC
  SDL_joystickbuttonnames.c SDL_joystickbuttonnames.h)
target_link_libraries(SDL_joystickbuttonnames ${SDL2_LIBRARY})

=== src/cdogs/cwolfmap/CMakeLists.txt ===
set(CW_SOURCES audio.c audio_sod.c audio_wl1.c audio_wl6.c cwolfmap.c expand.c vswap.c mame/fmopl.c)
set(CWHEADERS AUDIOSOD.H AUDIOWL1.H audiowl6.h audio.h audio_sod.h audio_wl1.h audio_wl6.h common.h cwolfmap.h expand.h vswap.h mame/fmopl.h)

add_library(cwolfmap STATIC ${CW_SOURCES} ${CWHEADERS})
if(NOT WIN32)
	target_link_libraries(cwolfmap m)
endif()

=== debian/changelog ===
cdogs-sdl (2.0.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Update copyrights.
  * Override lintian warning "no-manual-page".
  * Clean generated files in source directory.
  * Run tests non-parallel to prevent interference between each other.
  * Simplify nanopb header generation.
  * Fix build with FORTIFY_SOURCE level 3 (as set by Ubuntu)
    - raise inline limit
    - don't error on string truncation warnings

 -- Reiner Herrmann <reiner@reiner-h.de>  Sun, 18 Feb 2024 13:33:34 +0100

=== debian/control ===
Source: cdogs-sdl
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Reiner Herrmann <reiner@reiner-h.de>
Build-Depends: debhelper-compat (= 13),
               cmake,
               libenet-dev,
               libnanopb-dev (>= 0.4.8-1~),
               libsdl2-dev,
               libsdl2-image-dev,
               libsdl2-mixer-dev,
               nanopb
Standards-Version: 4.6.2
Homepage: https://cxong.github.io/cdogs-sdl/
Vcs-Git: https://salsa.debian.org/games-team/cdogs-sdl.git
Vcs-Browser: https://salsa.debian.org/games-team/cdogs-sdl
Rules-Requires-Root: no

Package: cdogs-sdl
Architecture: any
Built-Using: ${Built-Using}
Depends: ${shlibs:Depends}, ${misc:Depends}, cdogs-sdl-data (= ${source:Version})
Description: classic overhead run-and-gun game
 C-Dogs SDL is an overhead shoot-em-up which lets players work alone and
 cooperatively during missions or fight against each other in the
 "dogfight" deathmatch mode.
 .
 Customize your player, choose from many weapons, and blast, slide and
 slash your way through over 100 user-created campaigns.

Package: cdogs-sdl-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: classic overhead run-and-gun game - data files
 C-Dogs SDL is an overhead shoot-em-up which lets players work alone and
 cooperatively during missions or fight against each other in the
 "dogfight" deathmatch mode.
 .
 Customize your player, choose from many weapons, and blast, slide and
 slash your way through over 100 user-created campaigns.
 .
 This package contains the data files for C-Dogs SDL.

## cdogs-sdl 2.1.0+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 project(cdogs-sdl C)
 
 set(VERSION_MAJOR "2")
-set(VERSION_MINOR "0")
+set(VERSION_MINOR "1")
 set(VERSION_PATCH "0")
 set(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")
 
@@ -122,8 +122,9 @@
 		endif()
 		if (CMAKE_C_COMPILER_VERSION VERSION_GREATER 7)
 			add_definitions(
-				-Wimplicit-fallthrough=0 # TODO: is everything caught by implicit-fallthrough intended?
+				-C
 				-Wno-error=format-overflow # TODO: should probably just make sure buffer sizes are appropriate
+				-Wno-error=stringop-overflow # TODO: update nuklear
 			)
 		endif()
 	endif()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -33,7 +33,9 @@
 	menu.c
 	menu_utils.c
 	namegen.c
+	options_menu.c
 	password.c
+	pause_menu.c
 	player_select_menus.c
 	prep.c
 	prep_equip.c
@@ -56,7 +58,9 @@
 	menu.h
 	menu_utils.h
 	namegen.h
+	options_menu.h
 	password.h
+	pause_menu.h
 	player_select_menus.h
 	prep.h
 	prep_equip.h

=== src/cdogs/CMakeLists.txt ===
include_directories(
	.. # to include proto
	${SDL2_INCLUDE_DIRS})
add_definitions(-DSTATIC)
set(CDOGS_SOURCES
	actor_fire.c
	actor_placement.c
	actors.c
	aheasing/easing.c
	ai.c
	ai_context.c
	ai_coop.c
	ai_utils.c
	algorithms.c
	ammo.c
	animation.c
	AStar.c
	automap.c
	blit.c
	bullet_class.c
	c_array.c
	camera.c
	campaign_entry.c
	campaigns.c
	character.c
	character_class.c
	collision/collision.c
	collision/minkowski_hex.c
	color.c
	config.c
	config_apply.c
	config_io.c
	config_json.c
	config_old.c
	cpic.c
	damage.c
	defs.c
	door.c
	draw/char_sprites.c
	draw/draw.c
	draw/draw_actor.c
	draw/draw_buffer.c
	draw/drawtools.c
	draw/nine_slice.c
	emitter.c
	events.c
	files.c
	font.c
	font_utils.c
	game_events.c
	game_mode.c
	gamedata.c
	grafx.c
	grafx_bg.c
	handle_game_events.c
	hud/fps.c
	hud/gauge.c
	hud/health_gauge.c
	hud/hud.c
	hud/hud_num_popup.c
	hud/player_hud.c
	hud/wall_clock.c
	joystick.c
	json_utils.c
	keyboard.c
	log.c
	los.c
	map.c
	map_archive.c
	map_build.c
	map_cave.c
	map_classic.c
	map_interior.c
	map_new.c
	map_object.c
	map_static.c
	map_wolf.c
	material.c
	mathc/mathc.c
	mission.c
	mission_convert.c
	mission_static.c
	mouse.c
	music.c
	net_client.c
	net_server.c
	net_util.c
	objective.c
	objs.c
	palette.c
	particle.c
	path_cache.c
	pic.c
	pic_manager.c
	pickup.c
	pickup_class.c
	pics.c
	player.c
	player_template.c
	powerup.c
	quick_play.c
	screen_shake.c
	sounds.c
	texture.c
	thing.c
	tile.c
	tile_class.c
	triggers.c
	utils.c
	vector.c
	weapon.c
	weapon_class.c
	window_context.c
	XGetopt.c
	yajl_utils.c)
set(CDOGS_HEADERS
	actor_fire.h
	actor_placement.h
	actors.h
	aheasing/easing.h
	ai.h
	ai_context.h
	ai_coop.h
	ai_utils.h
	algorithms.h
	ammo.h
	animation.h
	AStar.h
	automap.h
	blit.h
	bullet_class.h
	c_array.h
	camera.h
	campaign_entry.h
	campaigns.h
	character.h
	character_class.h
	collision/collision.h
	collision/minkowski_hex.h
	color.h
	config.h
	config_io.h
	config_json.h
	config_old.h
	cpic.h
	damage.h
	defs.h
	door.h
	draw/char_sprites.h
	draw/draw.h
	draw/draw_actor.h
	draw/draw_buffer.h
	draw/drawtools.h
	draw/nine_slice.h
	emitter.h
	events.h
	files.h
	font.h
	font_utils.h
	game_events.h
	game_mode.h
	gamedata.h
	grafx.h
	grafx_bg.h
	handle_game_events.h
	hud/fps.h
	hud/gauge.h
	hud/health_gauge.h
	hud/hud.h
	hud/hud_defs.h
	hud/hud_num_popup.h
	hud/player_hud.h
	hud/wall_clock.h
	joystick.h
	json_utils.h
	keyboard.h
	log.h
	los.h
	map.h
	map_archive.h
	map_build.h
	map_cave.h
	map_classic.h
	map_interior.h
	map_new.h
	map_object.h
	map_static.h
	map_wolf.h
	material.h
	mathc/mathc.h
	mission.h
	mission_convert.h
	mission_static.h
	mouse.h
	music.h
	net_client.h
	net_server.h
	net_util.h
	objective.h
	objs.h
	palette.h
	particle.h
	path_cache.h
	pic.h
	pic_manager.h
	pickup.h
	pickup_class.h
	pics.h
	player.h
	player_template.h
	powerup.h
	quick_play.h
	screen_shake.h
	sounds.h
	sys_config.h
	sys_specifics.h
	texture.h
	thing.h
	tile.h
	tile_class.h
	triggers.h
	utils.h
	vector.h
	weapon.h
	weapon_class.h
	window_context.h
	XGetopt.h
	yajl_utils.h)

if(NOT USE_SHARED_ENET)
    add_subdirectory(enet)
endif()

add_subdirectory(c_hashmap)
add_subdirectory(cwolfmap)
add_subdirectory(SDL_JoystickButtonNames)
add_subdirectory(yajl)

add_library(cdogs STATIC
	${CDOGS_SOURCES} ${CDOGS_HEADERS})

target_link_libraries(cdogs
	c_hashmap
	cwolfmap
	json
	SDL_joystickbuttonnames
	yajl_s
	SDL2::SDL2
	SDL2_image::SDL2_image
	SDL2_mixer::SDL2_mixer
	${ENet_LIBRARIES})

=== src/json/CMakeLists.txt ===
if(MSVC)
	add_definitions(-wd"4996")
else()
	add_definitions(-Wno-error)
endif()

add_library(json STATIC json.c json.h)

=== src/proto/CMakeLists.txt ===
# Note: build fails if this is placed within cdogs/ folder
include_directories(${NANOPB_INCLUDE_DIRS})

add_definitions(-DPB_FIELD_16BIT)	# Allow larger field numbers in nanopb

# Note: uncomment below line to build new proto files
# nanopb_generate_cpp(PROTO_SRCS PROTO_HDRS msg.proto)
set(PROTO_SRCS "msg.pb.c" "nanopb/pb_decode.c" "nanopb/pb_encode.c" "nanopb/pb_common.c")
set(PROTO_HDRS "msg.pb.h" "nanopb/pb_decode.h" "nanopb/pb_encode.c" "nanopb/pb_common.c" "nanopb/pb.h")

include_directories(${CMAKE_CURRENT_BINARY_DIR})
add_library(cdogs_proto STATIC ${PROTO_SRCS} ${PROTO_HDRS} msg.options msg.proto)

=== src/tests/CMakeLists.txt ===
if(MSVC)
	add_definitions(-wd"4127" -wd"4102")
else()
	if(NOT BEOS AND NOT HAIKU)
		add_definitions(-Wno-unused-label)
		set(EXTRA_LIBRARIES "m")
	endif()
endif()

add_subdirectory(cbehave)

include_directories(
	. ../cdogs
	${SDL2_INCLUDE_DIRS})

add_executable(animated_counter_test
	animated_counter_test.c
	../animated_counter.h
	../animated_counter.c)
target_link_libraries(animated_counter_test
	cbehave
	cdogs
	cdogs_proto
	SDL2::SDL2
	${EXTRA_LIBRARIES})
add_test(NAME animated_counter_test COMMAND animated_counter_test)

add_executable(actor_test
	actor_test.c
	../cdogs/actors.h
	../cdogs/actors.c)
target_link_libraries(actor_test
	cbehave
	cdogs
	cdogs_proto
	SDL2::SDL2
	${EXTRA_LIBRARIES})
add_test(NAME actor_test COMMAND actor_test)

add_executable(autosave_test
	autosave_test.c
	../autosave.h
	../autosave.c)
target_link_libraries(autosave_test
	cbehave
	cdogs
	cdogs_proto
	SDL2::SDL2
	${EXTRA_LIBRARIES})
add_test(NAME autosave_test COMMAND autosave_test)

add_executable(c_hashmap_test
	c_hashmap_test.c
	../cdogs/c_hashmap/hashmap.h
	../cdogs/c_hashmap/hashmap.c)
target_link_libraries(c_hashmap_test cbehave ${EXTRA_LIBRARIES})
add_test(NAME c_hashmap_test COMMAND c_hashmap_test)

add_executable(c_array_test
	c_array_test.c
	../cdogs/c_array.h
	../cdogs/c_array.c)
target_link_libraries(c_array_test
	cbehave ${EXTRA_LIBRARIES})
add_test(NAME c_array_test COMMAND c_array_test)

add_executable(color_test
	color_test.c
	../cdogs/color.c
	../cdogs/color.h)
target_link_libraries(color_test cbehave ${EXTRA_LIBRARIES})
add_test(NAME color_test COMMAND color_test)

add_executable(config_test config_test.c)
target_link_libraries(config_test
	cbehave
	cdogs
	cdogs_proto
	SDL2::SDL2
	${EXTRA_LIBRARIES})
add_test(NAME config_test COMMAND config_test)

add_executable(json_test json_test.c)
target_link_libraries(json_test
	cbehave
	cdogs
	cdogs_proto
	SDL2::SDL2
	${EXTRA_LIBRARIES})
add_test(NAME json_test COMMAND json_test)

add_executable(minkowski_hex_test minkowski_hex_test.c)
target_link_libraries(minkowski_hex_test
	cbehave
	cdogs
	cdogs_proto
	SDL2::SDL2
	${EXTRA_LIBRARIES})
add_test(NAME minkowski_hex_test COMMAND minkowski_hex_test)

add_executable(pic_test pic_test.c)
target_link_libraries(pic_test
	cbehave
	cdogs
	cdogs_proto
	SDL2::SDL2
	SDL2_image::SDL2_image
	${EXTRA_LIBRARIES})
# TODO: test disabled since Travis-CI fails with "No available video device"
#add_test(NAME pic_test COMMAND pic_test)

add_executable(player_test player_test.c)
target_link_libraries(player_test
	cbehave
	cdogs
	cdogs_proto
	SDL2::SDL2
	${EXTRA_LIBRARIES})
add_test(NAME player_test COMMAND player_test)

add_executable(utils_test utils_test.c)
target_link_libraries(utils_test
	cbehave
	cdogs
	cdogs_proto
	SDL2::SDL2 ${EXTRA_LIBRARIES})
add_test(NAME utils_test COMMAND utils_test)

=== src/cdogs/cwolfmap/CMakeLists.txt ===
set(CW_SOURCES audio.c audio_bs6.c audio_n3d.c audio_sod.c audio_wl1.c audio_wl6.c cwolfmap.c expand.c n3d.c vswap.c mame/fmopl.c)
set(CWHEADERS audiobs6.h audion3d.h AUDIOSOD.H AUDIOWL1.H audiowl6.h audio.h audio_bs6.h audio_n3d.h audio_sod.h audio_wl1.h audio_wl6.h common.h cwolfmap.h expand.h n3d.h vswap.h mame/fmopl.h)

add_subdirectory(wad)
add_subdirectory(zip)

add_library(cwolfmap STATIC ${CW_SOURCES} ${CWHEADERS})
target_link_libraries(cwolfmap wad zip SDL2::SDL2)
if(NOT WIN32)
	target_link_libraries(cwolfmap m)
endif()

=== src/tests/cbehave/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(cbehave C)

include_directories(.)

if(MSVC)
	add_definitions(-wd"4127" -wd"4102" -wd"4996")
else()
	if(NOT BEOS AND NOT HAIKU)
		add_definitions(-Wno-unused-label -Wno-array-bounds)
	endif()
endif()

#add_subdirectory(examples)

add_library(cbehave STATIC cbehave.h cbehave.c apr_ring.h rlutil/rlutil.h)

=== src/cdogs/cwolfmap/wad/CMakeLists.txt ===
set(WAD_SOURCES wad.c waderrno.c)
set(WAD_HEADERS wad.h wad_config.h waderrno.h)

if(MSVC)
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -MP -W4 -WX -wd\"4018\" -wd\"4057\" -wd\"4100\" -wd\"4267\" -wd\"4273\" -wd\"4706\"")
else()
	add_definitions(
		-fsigned-char
		-Wall -W
		-Wpointer-arith
		-Wno-cast-qual -Wno-conversion -Wno-parentheses -Wno-pointer-sign -Wno-sign-compare -Wno-strict-prototypes -Wno-switch -Wno-unused-parameter)
endif()

add_library(wad STATIC ${WAD_SOURCES} ${WAD_HEADERS})

=== src/cdogs/cwolfmap/zip/CMakeLists.txt ===
set(ZIP_SOURCES zip.c)
set(ZIP_HEADERS zip.h miniz.h)

if(MSVC)
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -MP -W4 -WX -wd\"4127\" -wd\"4244\" -wd\"4267\" -wd\"4706\"")
else()
	add_definitions(
		-fsigned-char
		-Wall -W
		-Wstrict-prototypes -Wpointer-arith
		-Wno-cast-qual -Wno-conversion)
endif()

add_library(zip STATIC ${ZIP_SOURCES} ${ZIP_HEADERS})

=== debian/changelog ===
cdogs-sdl (2.1.0+dfsg-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Backport upstream fix for FTBFS with CMake 4. (Closes: #1112770)

 -- Adrian Bunk <bunk@debian.org>  Sat, 18 Oct 2025 20:24:58 +0300

cdogs-sdl (2.1.0+dfsg-2) unstable; urgency=medium

  * Team Upload

  [ Reiner Herrmann ]
  * Fix FTBFS with gcc 14 (Closes: #1074873)

 -- Alexandre Detiste <tchet@debian.org>  Sat, 03 Aug 2024 18:47:09 +0200

cdogs-sdl (2.1.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Update copyrights.
  * Declare compliance with Debian Policy 4.7.0.
  * Override lintian error about embedded yajl library, as it has been
    modified and can't be easily removed.

 -- Reiner Herrmann <reiner@reiner-h.de>  Sun, 14 Apr 2024 14:32:06 +0200

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
                libsdl2-image-dev,
                libsdl2-mixer-dev,
                nanopb
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://cxong.github.io/cdogs-sdl/
 Vcs-Git: https://salsa.debian.org/games-team/cdogs-sdl.git
 Vcs-Browser: https://salsa.debian.org/games-team/cdogs-sdl

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# nanopb headers are in /usr/include/nanopb, but generated msg.pb.h
# header includes <pb.h>
export DEB_CPPFLAGS_MAINT_APPEND = -I/usr/include/nanopb

# fix build with FORTIFY_SOURCE level 3
# https://github.com/cxong/cdogs-sdl/issues/838
export DEB_CFLAGS_MAINT_APPEND = -finline-limit=1000 -Wno-stringop-truncation

%:
	dh $@

src/proto/msg.pb.c src/proto/msg.pb.h &: src/proto/msg.proto
	cd src/proto && protoc --nanopb_out=. msg.proto

override_dh_auto_configure: src/proto/msg.pb.c src/proto/msg.pb.h
	dh_auto_configure -- \
		-DCDOGS_BIN_DIR=/usr/games \
		-DCDOGS_DATA_DIR=/usr/share/games/cdogs-sdl/ \
		-DUSE_SHARED_ENET=ON \
		-DDEBUG=ON \
		-DBUILD_EDITOR=OFF

execute_before_dh_installdocs:
	rm -r $(CURDIR)/debian/tmp/usr/doc

execute_before_dh_install:
	find $(CURDIR)/debian/tmp -type f '(' -iname "LICENSE.md" -o -iname "README.md" -o -name "*.sh" ')' -delete
	# delete txt files (containing only license/copyright information), except a few important ones
	find $(CURDIR)/debian/tmp -type f '(' -name "*.txt" -a '!' \
		'(' -name 'gamecontroller*db.txt' -o -name 'prefixes.txt' -o -name 'suffix*.txt' ')' ')' -delete

override_dh_gencontrol:
	dh_gencontrol -- -VBuilt-Using="$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W "libnanopb-dev")"

override_dh_auto_test:
	dh_auto_test --no-parallel

=== debian/watch ===
version=4
opts="dversionmangle=s/\+dfsg\d*$//,repacksuffix=+dfsg" \
https://github.com/cxong/cdogs-sdl/tags .*/@ANY_VERSION@@ARCHIVE_EXT@
